#if !defined(_ADATA_PORTABILITY_H)
#define _ADATA_PORTABILITY_H

/*
** File: portability.h  
** Project: API libraries
** Purpose: VxWorks-specific definitions for abstracting the platform
**
** (C) Copyright Alpha Data 2011
*/

#include <vxWorks.h>
#include <semLib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

typedef int bool_t;
typedef FILE* portable_file_t;
#define PORTABLE_INVALID_FILE (NULL)

#define PORTABLE_HAS_USER_EVENT_HANDLE (1)
typedef SEM_ID portable_user_event_handle_t;

#define PORTABLE_HAS_WCHAR_SUPPORT (0)

#if !defined(TRUE)
#   define TRUE (1)
#endif
#if !defined(FALSE)
#   define FALSE (0)
#endif

#if (_WRS_VXWORKS_MAJOR >= 6)
# define portableFormatStringA1(buf, max, format, arg1) snprintf(buf, max, format, arg1)
# define portableFormatStringA2(buf, max, format, arg1, arg2) snprintf(buf, max, format, arg1, arg2)
# define portableFormatStringA3(buf, max, format, arg1, arg2, arg3) snprintf(buf, max, format, arg1, arg2, arg3)
# define portableFormatStringA4(buf, max, format, arg1, arg2, arg3, arg4) snprintf(buf, max, format, arg1, arg2, arg3, arg4)
#else
  /* Need VxWorks 6.x for snprintf() */
# define portableFormatStringA1(buf, max, format, arg1) sprintf(buf, format, arg1)
# define portableFormatStringA2(buf, max, format, arg1, arg2) sprintf(buf, format, arg1, arg2)
# define portableFormatStringA3(buf, max, format, arg1, arg2, arg3) sprintf(buf, format, arg1, arg2, arg3)
# define portableFormatStringA4(buf, max, format, arg1, arg2, arg3, arg4) sprintf(buf, format, arg1, arg2, arg3, arg4)
#endif

#endif
